from xbmctorrentV2.plugin import plugin
import xbmc,xbmcaddon,xbmcgui
from xbmctorrentV2 import subtitles
getSetting = xbmcaddon.Addon().getSetting


PUBLIC_TRACKERS = [
    "udp://tracker.publicbt.com:80/announce",
    "udp://tracker.openbittorrent.com:80/announce",
    "udp://open.demonii.com:1337/announce",
    "udp://tracker.istole.it:6969",
    "udp://tracker.coppersurfer.tk:80",
]


# Add default trackers to a magnet link, to improve its reachability
def _boost_magnet(magnet):
    from urllib import urlencode
    return "%s&%s" % (magnet, urlencode({"tr": PUBLIC_TRACKERS}, True))


def from_torrent_url(url):
    import base64
    import bencode
    import hashlib
    import urllib
    from xbmctorrentV2.utils import url_get
    torrent_data = url_get(url)
    metadata = bencode.bdecode(torrent_data)
    hashcontents = bencode.bencode(metadata['info'])
    digest = hashlib.sha1(hashcontents).digest()
    b32hash = base64.b32encode(digest)
    params = {
        'dn': metadata['info']['name'],
        'tr': metadata['announce'],
    }
    plugin.log.info(params)
    paramstr = urllib.urlencode(params)
    return 'magnet:?%s&%s' % ('xt=urn:btih:%s' % b32hash, paramstr)


def ensure_magnet(uri):
    if not uri.startswith("magnet:"):
        uri = from_torrent_url(uri)
    return uri


def display_name(magnet_uri):
    import urlparse
    from xbmctorrentV2.utils import first
    magnet_args = urlparse.parse_qs(magnet_uri.replace("magnet:?", ""))
    return first(magnet_args.get("dn", []))


@plugin.route("/play/<uri>")
def play(uri):
	from xbmctorrentV2.player import TorrentPlayer
	subtitle = ''
	try:
		season=''
		episode=''
		tagname = xbmc.getInfoLabel("ListItem.Label")
		try: imdb = xbmc.getInfoLabel("ListItem.MPAA")
		except: imdb = ''
		try: name = xbmc.getInfoLabel("ListItem.OriginalTitle")
		except: 
			try: name = xbmc.getInfoLabel("ListItem.Title")
			except: name = xbmc.getInfoLabel("ListItem.Label")
		if xbmc.getInfoLabel("ListItem.TVShowTitle") <> '':
				tagname = xbmc.getInfoLabel("ListItem.TVShowTitle")
				name = xbmc.getInfoLabel("ListItem.TVShowTitle")
				season = xbmc.getInfoLabel("ListItem.Season")
				episode = xbmc.getInfoLabel("ListItem.Episode")
				imdb = ''				
		if getSetting("subtitles") == 'true': subtitle = subtitles.getsubtitles(name,tagname,season,episode,getSetting("sublang1"),getSetting("sublang2"),imdb)
	except: pass	
	if uri.startswith("magnet:") and plugin.get_setting("magnet_boost", bool):
		plugin.log.info("Enabled magnet booster")
		uri = _boost_magnet(uri)
	TorrentPlayer().init(uri,subtitle).loop()
